import os
import numpy as np
from matplotlib import image
from pyts.image.gaf import GramianAngularField
file_name = "file_path"
save_path = "save_path"
img_size = 256
window_size = 300
step = 150
assert window_size >= img_size
method = 'difference'
print("GAF method：%s，image size：%d * %d" % (method, img_size, img_size))
img_path = "%s/file_name" % save_path
data_path = "%s/data" % save_path
if not os.path.exists(img_path):
    os.makedirs(img_path)
if not os.path.exists(data_path):
    os.makedirs(data_path)
print("start output...")
print("save image in %s ，data save in %s " % (img_path, data_path))
gaf = GramianAngularField(image_size=img_size, method=method)
data = np.loadtxt(file_name, delimiter=",").reshape(1, -1)
_, n_sample = data.shape
img_num = 0
start_index, end_index = 0, window_size
while end_index <= n_sample:
    img_num += 1
    sub_series = data[:, start_index:end_index]
    gaf_img = gaf.fit_transform(sub_series)
    img_save_path = "{}/{}.png".format(img_path, img_num)
    data_save_path = "{}/{}.csv".format(data_path, img_num)
    image.imsave(img_save_path, gaf_img[0])
    np.savetxt(data_save_path, gaf_img[0], delimiter=',')
    start_index += step
    end_index += step
print("finsh，total {} pictures。".format(img_num))
