import numpy as np
from sklearn.manifold import TSNE
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
output = np.load('train/fca_output.npy').astype(np.float64)
data = np.load('train/fca_data.npy')
target = np.load('train/fca_target.npy')
print('data shape: ', data.shape)
print('target shape: ', target.shape)
print('output shape: ', output.shape)
model = TSNE(n_components=2, random_state=1100)
output_2d = model.fit_transform(output)
np.save('train/fca_output1.npy', output_2d, allow_pickle=False)
plt.rc('font', family='Times New Roman', size=16)
fig = plt.figure(figsize=(7, 7))
scatter = plt.scatter(output_2d[:, 0], output_2d[:, 1], c=target, s=30)
legend1 = fig.legend(*scatter.legend_elements(), loc="upper right", title="fault label")
plt.legend()
plt.savefig('train/fca_tsne.png', bbox_inches='tight', dpi=300)
plt.show()
data_num = data.shape[0]
data_new = np.reshape(data, (data_num, -1)).astype(np.float64)
print('data_new shape: ', data_new.shape)
data_2d = model.fit_transform(data_new)
np.save('train/fca_data1.npy', data_2d, allow_pickle=False)
fig = plt.figure(figsize=(7, 7))
scatter = plt.scatter(data_2d[:, 0], data_2d[:, 1], c=target, s=30)
legend2 = fig.legend(*scatter.legend_elements(), loc="upper right", title="Fault types")
plt.legend()
plt.savefig('train/fca_orange.png', bbox_inches='tight', dpi=300)
plt.show()
